$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$! Make Bending Magnet files of SHADOW.
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$ say :== write sys$output
$
$ say " "
$ say "# Building the Bending Magnet Modules of SHADOW/VMS #"
$ say " "
$
$!
$! Define the symbols necessary for compilation.
$!
$
$! set on
$! on error then goto CLEANUP
$! on control_c then goto CLEANUP
$! on control_y then goto CLEANUP
$
$ on error then continue
$ on warning then continue
$ on severe then continue
$
$
$!
$! Define the compilation flags. These flags are actually reset in
$! COMPILE.COM, so watch out.
$!
$
$ defines 	= " "
$ ccompile 	= "cc'defines'/undefine=(ANSI_LIB)/debug/nooptimize"
$ fcompile 	= "fortran'defines'/debug/nooptimize"
$ compile	= "@[-.-]compile.com"
$
$!
$! The libraries that are created here, and that are used in linking.
$!
$
$ libname 	= "libbm.olb"
$ libshadow	= "[-.-.lib]libshadow.olb"
$ libmath	= "[-.-.tools.math]libmath.olb"
$
$!
$! Go thru all subdirectories first (if any) and make those.
$!
$
$!
$! Compile all the source files.
$!
$
$!
$! create the local library first if it doesn't exist yet.
$!
$
$ if f$search(libname) .eqs. "" 
$ then 
$	say "Creating library ''libname'"
$	library/create 'libname'
$ endif
$ say " "
$
$
$ compile aladdin.for
$ compile bskm.for
$ compile bend_phot.for
$ compile compute.for
$ compile filesave.for
$ compile icdf.for
$ compile rcdf.for
$ compile setup.for
$ compile solve.for
$ compile white.for
$!!compile sincrad.for
$ compile srcdf.for 
$ compile srcomp.for
$ compile srfull.for
$ compile sync_spectra.for
$ compile beam.for
$ compile machine_par.for
$!compile power.for
$ compile srfunc.for
$!compile sincradl.for
$!compile sradpol.for
$!compile sradtot.for
$!compile srangplt.for
$!compile srtot.for
$!compile t_phot.for
$
$
$ say " "
$ say "Adding *.obj to library ''libname'"
$ say " "
$ library/replace 'libname' -
	aladdin, 	-
	bskm, 		-
	bend_phot, 	-
	compute, 	-
	filesave, 	-
	icdf, 		-
	rcdf, 		-
	setup, 		-
	solve, 		-
	white
$
$!
$! Make the final programs in this directory.
$!
$
$!
$! Define the libraries needed to link these programs here.
$!
$
$ libraries 	= "'libname'/lib, 'libshadow'/lib"
$
$!say "Linking... sincrad"
$!link sincrad, 'libraries'
$ say "Linking... srcdf"
$ link srcdf, 'libraries'
$ say "Linking... srcomp"
$ link srcomp, 'libraries'
$ say "Linking... srfull"
$ link srfull, 'libraries'
$ say "Linking... srfunc"
$ link srfunc, 'libraries'
$ say "Linking... sync_spectra"
$ link sync_spectra, 'libraries'
$ say "Linking... beam"
$ link beam, 'libraries'
$ say "Linking... machine_par"
$ link machine_par, 'libraries'
$! say "Linking... power"
$! link power, 'libraries'
$
$ say "Creating ... G0UNF G0FUNC"
$ run srfunc
$
$ say "Creating ... SRDISTR SRANG SRSPEC"
$ run srcdf
	4
$
$
$ CLEANUP:
$ delete/sym libraries
$ say " Copying Bending Magnet Data files to data dir "
$ copy/log srang.dat [-.-.data]
$ copy/log srspec.dat [-.-.data]
$ copy/log srdistr.dat [-.-.data]
$ copy/log g0unf.dat [-.-.data]
$ copy/log g0func.dat [-.-.data]
$ say " "
$ say "# Done Making the Bending Magnet Modules of SHADOW/VMS #"
$ say " "
$
$ EXIT
