C +++
C
C Source: src/source/bm/sincrad.f
C
C ----------------------------------------------
C                SHADOW
C      Center for X-ray Lithography
C     University of Wisconsin-Madison
C  3731 Schneider Dr., Stoughton, WI, 53589
C ----------------------------------------------
C 
C Log:	sincrad.f
C Revision 1.2  90/07/18  19:37:30  khan
C Unixified the programs by removing non standard features, most notably
C DEC's DO .. END DO strucutures.
C 
C Revision 1.1  90/07/11  10:45:00  khan
C Initial revision
C 
C 
C ---
	PROGRAM	SINCRAD
C**************************************************************
C	THIS PROGRAM COMPUTE THE FLUX DISTRIBUTION VS. ELEVATION
C	ANGLE PSI.BANDPASS IS 1 EV.
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER*1 Q

#if defined(unix) || HAVE_F77_CPP
#       include		"bm.blk"
#elif defined(vms)
	INCLUDE		'bm.blk'
#endif

1	CALL INPUT
	CALL SETUP
	CALL COMPUTE
	CALL FILESAVE
	WRITE (6,100)
100	FORMAT(1X,'DONE. ANOTHER RUN (Y/N) ?',$)
	READ(6,110) Q
110	FORMAT(A8)
	IF (Q.EQ.'Y') GO TO 1
	STOP 'SEE YOU LATER !'
	END
C*******************************************************************
	SUBROUTINE INPUT
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER *6 FILSAV,Q
#if 0
	COMMON/FIRST/PPAR(100,2),PPER(100,2),PTOT(100,2)
	COMMON/SECON/PHOT,BENER,THETA,NP,STEP,X,N,BK,IER,GAMM
	COMMON/THIRD/RAD,RLCR,RL,FCT,CONST,ARG,PSIMAX
	COMMON/FOURT/FILSAV,Q
	COMMON/FIFTH/IC,PSI,IDATA
#else

# if defined(unix) || HAVE_F77_CPP
#       include		"bm.blk"
# elif defined(vms)
	INCLUDE		'bm.blk'
# endif
#endif

	WRITE (6,100)
100	FORMAT(1X,'BEAM ENERGY IN GeV = ',$)
	READ(5,*)BENER
	WRITE (6,110)
110	FORMAT(1X,'PHOTON ENERGY IN eV =',$)
	READ(5,*)PHOT
	WRITE(6,120)
120	FORMAT(1X,'ACCEPTANCE ANGLE IN mrad = ',$)
	READ(5,*)THETA
	WRITE(6,130)
130	FORMAT(1X,'PSI MAXIMUM IN mrad = ',$)
	READ(5,*) PSIMAX
	WRITE(6,140)
140 	FORMAT(1X,'NUMBER OF POINTS (ODD) = ',$)
	READ(5,*)NP
	WRITE (6,150)
150	FORMAT(1X,'NAME FOR STORAGE = ',$)
	READ(6,160) FILSAV
160 	FORMAT (A6)
	RETURN
	END
C*****************************************************************
