$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$! Make insertion device files of SHADOW.
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$ say 	:== write sys$output
$
$ say " "
$ say "# Making the Insertion Devices Modules of SHADOW/VMS #"
$ say " "
$
$!
$! Define the symbols necessary for compilation.
$!
$
$! set on
$! on error then goto CLEANUP
$! on control_c then goto CLEANUP
$! on control_y then goto CLEANUP
$
$ on error then continue
$ on warning then continue
$ on severe then continue
$
$
$!
$! Define the compilation flags. These flags are actually reset in
$! COMPILE.COM, so watch out.
$!
$
$ defines 	:=
$ ccompile 	:= cc'defines'/undefine=(ANSI_LIB)/debug/nooptimize
$ fcompile 	:= fortran'defines'/debug/nooptimize
$ compile	:= @[-.-]compile.com
$
$!
$! The libraries that are created here, and that are used in linking.
$!
$
$ libname 	:= libid.olb
$ libshadow	:= [-.-.lib]libshadow.olb
$ libmath	:= [-.-.tools.math]libmath.olb
$
$!
$! Go thru all subdirectories (if any) first and make those.
$!
$
$!
$! Compile all the source files.
$!
$
$!
$! create the local library first if it doesn't exist yet.
$!
$
$ if f$search(libname) .eqs. "" 
$ then 
$	say "Creating library ''libname'"
$	library/create 'libname'
$ endif
$ say " "
$
$ compile inv_linear.for
$ compile report.for
$ compile rns.for
$ compile rw_undul.for
$ compile ucdf.for
$ compile uinvert.for
$ compile undul_shadow_io.for
$ compile undul_user_io.for
$ compile uphoton.for
$ compile uread.for
$ compile user_undul.for
$ compile uwrite.for
$
$ compile epath.for
$ compile nphoton.for
$ compile undul_cdf.for
$ compile undul_phot.for 
$ compile undul_set.for
$
$
$ say " "
$ say "Adding *.obj to library ''libname'"
$ say " "
$ library/replace 'libname' -
	inv_linear, 	-
	report, 	-
	rns, 		-
	rw_undul, 	-
	ucdf, 		-
	ucdf, 		-
	uinvert, 	-
	undul_shadow_io, -
	undul_user_io, 	-
	uphoton, 	-
	uread, 		-
	user_undul, 	-
	uwrite
$
$!
$! Make the final programs in this directory.
$!
$
$!
$! Define the libraries needed to link these programs here.
$!
$
$ libraries 	= "'libname'/lib, 'libshadow'/lib, 'libmath'/lib"
$
$ say "Linking... epath"
$ link epath, 'libraries
$ say "Linking... nphoton"
$ link nphoton, 'libraries
$ say "Linking... undul_cdf"
$ link undul_cdf, 'libraries
$ say "Linking... undul_phot"
$ link undul_phot, 'libraries
$ say "Linking... undul_set"
$ link undul_set, 'libraries
$ say "Linking... user_undul"
$ link user_undul, 'libraries
$
$ CLEANUP:
$ say " "
$ say "# Done Making the Insertion Devices Modules of SHADOW/VMS #"
$ say " "
$
$ EXIT
